#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

typedef struct P
{
	char* ime;
	char* poruka;
	int x,y;
	
	struct P *sledeci;
	
}poklon;

#define novi(x) x = (poklon*) malloc(sizeof(poklon))
#define take(s,c) s = (char*) malloc(strlen(c)+1)

void Ispisi(poklon *p)
{
	if(p)
	{
		printf("\n\n------LISTA POKLONA---------\n\n");
		while(p)
		{
			printf("*%s* *%s* *%d* *%d*\n",p->ime,p->poruka,p->x,p->y);
			p = p->sledeci;
		}
	}
	else printf("Lista je prazna.");
}

poklon* UnesiPoklon()
{
	poklon* clan;
	char str[50];
	novi(clan);
	
	getchar();
	printf("UNesite ime i prezime deteta\n");
		fgets(str,50,stdin);
		take(clan->ime,str);
		strcpy(clan->ime,str);
	
	printf("UNesite poruku\n");
		fgets(str,50,stdin);
		take(clan->poruka,str);
		strcpy(clan->poruka,str);
	
	printf("UNesite koordinate\n");
	scanf("%d",&(clan->x));
	scanf("%d",&(clan->y));
	
	return clan;
}

poklon* FormPoklon() //radi
{
	poklon	*p,*clan;
	p = NULL;
	
	int n;
	printf("Unesite broj poklona.\n");
	scanf("%d",&n);
	
	while(n--)
	{
		clan = UnesiPoklon();
		//printf("%s\n",clan->ime);
		clan->sledeci = p;
		p = clan;
	}
	
	return p;
}

int BrisiPoklon(poklon** p,int m,int *x, int *y)//za isto m
{
	
	poklon* move, *del;
	int ind = 0;

	while((move=*p)!=NULL && ( (sqrt(pow(move->x*10,2) - pow((*x)*10,2) ) < m) && (sqrt(pow(2,move->y*10) - pow(2,(*y)*10)) < m) ))
	{
		(*x) = move->x;
		(*y) = move->y;
		*p = move->sledeci;
		free(move);
		ind = 1;
	} //ZAMENILA SAM U POW DVOJKA IDE NA DRUGO MESTO A NE NA PRVO
	
	while(*p!=NULL && move->sledeci)
	{
		if((sqrt(pow(2,move->sledeci->x*10) - pow(2,(*x)*10)) < m) && (sqrt(pow(move->sledeci->y*10,2) - pow(2,(*y)*10)) < m))
		{
			(*x) = move->x;
			(*y) = move->y;
			del = move->sledeci;
			move = del->sledeci;
			free(del);
			ind = 1;
		}
		else move=move->sledeci;
	}
	
	return ind;
}

main()
{
	poklon* p,* move;
	int m;
	p = FormPoklon();
	Ispisi(p);
	
	printf("Koliko km Deda moze da predje?\n");
	scanf("%d",&m);
	int x = 0, y = 0;
	while(p!=NULL)
	{
		if(!BrisiPoklon(&p,m,&x,&y)) break;
		Ispisi(p);
	}

}
