#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
typedef struct lista{
	char dete[50];
	char poruka [255];
	int x;
	int y;
	struct lista* sledeci;
}lista;

lista *dodaj(lista *p, char dete[], char poruka[], int x, int y)
{  lista *trenutni=p, *novi;
   novi=(lista*)malloc(sizeof(lista));
   novi->sledeci=NULL;
   strcpy(novi->dete,dete);
   strcpy(novi->poruka,poruka);
   novi->x=x;
   novi->y=y;
   if(p==NULL)
     p=novi;
   else
     { 
	  while(trenutni->sledeci!=NULL)
		 trenutni=trenutni->sledeci;
	  trenutni->sledeci=novi;
  }
  return p;
} 


lista * Formiraj(char s[])
{ FILE *f=fopen(s,"r");
  lista *p=NULL;
  int i,n;
  fscanf(f,"%d",&n);
  fgetc(f);
  char dete[50], poruka [255];
  int x, y;
  for(i=0;i<n;i++)
    { fgets(dete,50,f);
	  fgets(poruka,255,f);
	  fscanf(f,"%d",&x);
	  fscanf(f,"%d",&y);
	  fgetc(f);
	  p=dodaj(p,dete,poruka,x,y);
  }
  return p;
}

void Ispis(lista *p)
{ lista *trenutni=p;
	while(trenutni!=NULL)
	  { printf("Ime deteta: %s",trenutni->dete);
		printf("Poruka: %s",trenutni->poruka);
		printf("x: %d\n",trenutni->x);
		printf("y: %d\n",trenutni->y);
		trenutni=trenutni->sledeci;
	}
}

float duzina(int dx, int dy,int x, int y)
{   long s1,s2;
	s1=(x-dx)*10;
	s2=(y-dy)*10;
	return (sqrt(pow(s1,2)+pow(s2,2)));
}   

lista *form2(lista *p, lista *q, float m, int x, int y)
{  lista  *brisi=NULL,*prethodni=NULL,*trenutni=p;
    while(trenutni!=NULL)
      {   
		  if((duzina(x,y,trenutni->x,trenutni->y)/100)>m)
		    { q=dodaj(q,trenutni->dete,trenutni->poruka,trenutni->x,trenutni->y);
			  prethodni=trenutni;
			  trenutni=trenutni->sledeci;
		  }
		  else if(trenutni==p)
		    {  
			   brisi=trenutni;
			   x=trenutni->x;
			   y=trenutni->y;
			   trenutni=trenutni->sledeci;
			   p=trenutni;
			   free(brisi);
			  
		   }
		  else
		    { brisi=trenutni;
			  x=trenutni->x;
			  y=trenutni->y;
			  trenutni=trenutni->sledeci;
			  prethodni->sledeci=trenutni;
			  free(brisi);
			  
		  }
	  }
	  
     return q;
 }
		    
    
int main(int argc, char* argv[])
{ 
  lista *p=NULL;
  lista *q=NULL;
  float m;
  p=Formiraj(argv[1]);
  Ispis(p);
  printf("\nUnesite broj M:\n");
  scanf("%f",&m);
  q=form2(p,q,m,0,0);
  printf("\n Nije Mogao da isporuci:\n");
  Ispis(q);
  return 0;
}
